# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

"""
This module provides access to the singleton application.

@var  application: the Elisa application
@type application: L{elisa.core.application.Application}
"""
import sys

application = None

booted = False

def set_application(app):
    global application
    application = app

def boot():
    global booted

    if not booted:

        try:
            from twisted.internet import glib2reactor
            glib2reactor.install()
        except AssertionError:
            pass

        from elisa.core import log

        if 'gst' in sys.modules:
            del sys.modules['gst']

        import pygst
        pygst.require('0.10')

        log.init()
        log.logTwisted()

        booted = True
