# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.



__maintainer__ = 'Florian Boucault <florian@fluendo.com>'

from elisa.extern.log import log

class Observable(log.Loggable, object):

    _observers = None

    def __init__(self):
        self._observers = []

    def __setattr__(self, key, value):
        object.__setattr__(self, key, value)
        if self._observers and key[0] != '_':
            for observer in self._observers:
                try:
                    observer.attribute_set(key, value)
                except Exception, e:
                    self.warning("Observer %s raised an exception while"
                                 " setting '%s' to '%s': %r" % (observer,
                                                                key,
                                                                value,
                                                                e)
                                  )

    def add_observer(self, observer):
        self._observers.append(observer)
