# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.


from twisted.trial import unittest

class ComponentTestCase(unittest.TestCase):

    component_class = None

    def __init__(self, methodName='runTest'):
        unittest.TestCase.__init__(self, methodName=methodName)

        try:
            cmpt = self.get_component()
        except ImportError, error:
            self.skip = error

    def get_component(self):
        component = None
        if self.component_class:
            if isinstance(self.component_class, basestring):
                # import!
                path = self.component_class
                mod_class = path.split(':')

                module = __import__(mod_class[0], globals(),
                                    locals(), [mod_class[1]])
                Class = getattr(module, mod_class[1])
                component = Class()
            else:
                component = self.component_class()

        # TODO: perform extra stuff that's normally done by the
        #       plugin registry create_component() method

        return component

    def setUp(self):
        unittest.TestCase.setUp(self)
        self.component = self.get_component()
