# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from elisa.core import log, common, application
from elisa.core import config, plugin_registry
from elisa.core.bus import bus
from twisted.trial import unittest
import os

class BoilerPlateApp:

    def __init__(self, config_file):
        self.config = config.Config(config_file)

        manager = plugin_registry.PluginRegistry(self.config)
        self.plugin_registry = manager
        self.bus = bus.Bus()

    def handle_traceback(self):
        pass

class ElisaTestCase(unittest.TestCase):

    def setUp(self):
        common.boot()

        if 'ELISA_DEBUG' not in os.environ:
            log.setDebug('*:0')

        app = BoilerPlateApp('empty.conf')
        default_config = application.DEFAULT_CONFIG % {'version': 'test',
                                                       'install_date': 'none'}
        app.config = config.Config('empty.conf', default_config)
        common.set_application(app)

    def check_called(self, callback):
        self.failUnless(hasattr(callback, 'called'))
        self.assertEquals(callback.called, True)
