# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.

from twisted.trial import unittest
from elisa.core.tests.elisa_test_case import ElisaTestCase

from elisa.core import plugin
import gettext

gettext.bindtextdomain("test", "i18n_test")
_ = lambda s: gettext.dgettext("test", s);

class TestPlug(plugin.Plugin):
    translation_path = "i18n_test"
    name = "test"

    def say_yes(self):
        return _("Yes this is a test")


class TestPlugin(ElisaTestCase):

    def test_i18n(self):
        """
        """
        t = TestPlug()
        self.assertEqual(t.say_yes(), "Yes this is a test")
