# -*- coding: utf-8 -*-
# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.


__maintainer__ = 'Florian Boucault <florian@fluendo.com>'


from list_model import ListModel


class MenuNodeModel(ListModel):
    """
    Modelize a menu node

    """
    text = ''
    theme_icon = 'unknown_icon'
    thumbnail_source = None # MediaUri instance
    has_children = False
    uri = None
    
    def __repr__(self):
        return "<MenuNodeModel instance %r for %r, %r children>" % (self.id,
                                                                    self.text,
                                                                    len(self))
    def __lt__(self, other):
        if isinstance(other, MenuNodeModel):
            return self.text.lower() < other.text.lower()
        return

    def __le__(self, other):
        if isinstance(other, MenuNodeModel):
            return self.text.lower() <= other.text.lower()
        return

    def __gt__(self, other):
        if isinstance(other, MenuNodeModel):
            #print self.text.lower(),other.text.lower(), self.text > other.text
            return self.text.lower() > other.text.lower()
        return

    def __ge__(self, other):
        if isinstance(other, MenuNodeModel):
            return self.text.lower() >= other.text.lower()
        return
