# Elisa - Home multimedia server
# Copyright (C) 2006,2007 Fluendo Embedded S.L. (www.fluendo.com).
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2.
# See "LICENSE.GPL" in the root of this distribution including a special
# exception to use Elisa with Fluendo's plugins.
#
# The GPL part of Elisa is also available under a commercial licensing
# agreement from Fluendo.
# See "LICENSE.Elisa" in the root directory of this distribution package
# for details on that license.


__maintainer__ = 'Florian Boucault <florian@fluendo.com>'
__maintainer2__ = 'Philippe Normand <philippe@fluendo.com>'


from elisa.base_components.model import Model


class PlayerModel(Model):

    # MediaURI instance
    uri = None
    # player.STATES enum value
    state = None
    # playlist (listmodel)
    playlist = None
    # position to seek in the file (in nanoseconds)
    seek_to = 0
    # whether or not the player is previewing the media
    preview_mode = False
    #Position (in nanoseconds) : READONLY
    #equal -1 if unknown
    position = -1
    #volume level (float between 0 and 10)
    volume = 1.0
    #mute (boolean)
    muted = False
    #duration (in nanoseconds) : READONLY
    #equal -1 if unknown
    duration = -1
    # should the player pause() next time OK key is pressed
    pause_requested = False

    # current content type being played by the player, can be 'audio'
    # or 'video'
    file_type = None
