
from elisa.core.tests import component_test_case
from elisa.plugins.base.metadata_providers.gst_metadata import GstMetadata
from elisa.core import media_uri

from twisted.internet import reactor
import os

class TestGstMetadata(component_test_case.ComponentTestCase):

    component_class = GstMetadata

    def test_able_to_handle(self):
        uri = media_uri.MediaUri('file://')

        able = self.component.able_to_handle({'uri': uri, 'content-type' :
        'audio'})
        self.assertEqual(able, True)

        able = self.component.able_to_handle({'uri': uri, 'content-type' :
        'video'})
        self.assertEqual(able, True)

        able = self.component.able_to_handle({'uri': uri, 'content-type' :
        'directory'})

        self.assertEqual(able, False)




    def test_get_metadata(self):

        def dict_filled(dict):
            static_tags = {'album': u'httpopenmusiclinuxtagorg',
                'encoder-version': 0L, 'track-number': 1L, 'artist':
                u'open_music', 'track': 1L, 'bitrate': 128000L, 'nominal-bitrate':
                128000L, 'uri':uri,
                'encoder': u'Xiphophorus libVorbis I 20010225', 'content-type':
                'audio', 'genre': u'other', 'title':
                u'open_source__magic_mushrooms', 'song':
                u'open_source__magic_mushrooms', 'audio-codec': u'Vorbis'}
            self.assertEqual(dict, static_tags)

        uri = media_uri.MediaUri("file://./../sample_data/music/01_open_source__magic_mushrooms.ogg")
        dfr = self.component.get_metadata({'uri': uri,
                                            'content-type':'audio'})
        dfr.addCallback(dict_filled)
        return dfr
