
from elisa.core.tests import component_test_case
from elisa.core.media_uri import MediaUri
import os
from twisted.internet import defer

class TestIpodMedia(component_test_case.ComponentTestCase):

    component_class = 'elisa.plugins.base.media_providers.ipod_media:IpodMedia'

    def __init__(self, methodName):
        component_test_case.ComponentTestCase.__init__(self, methodName)

        # FIXME: this test should use the iTunesDB in data/ ...

        if not os.path.exists('/media/IPOD'):
            msg = "ipod not found"
            TestIpodMedia.test_directory.im_func.skip = msg

    def test_directory(self):
        uri = MediaUri(u'ipod:///media/IPOD')
        dfr = self.component.is_directory(uri)
        dfr.addCallback(lambda validated: self.assertEquals(validated, True))

        uri = MediaUri(u'ipod:///media/IPOD?artist=Rammstein')
        dfr1 = self.component.is_directory(uri)
        dfr1.addCallback(lambda validated: self.assertEquals(validated, True))

        uri = MediaUri(u'ipod:///media/IPOD?id=1234')
        dfr2 = self.component.is_directory(uri)
        dfr2.addCallback(lambda validated: self.assertEquals(validated, False))
        return defer.DeferredList([dfr, dfr1, dfr2])
